echo Copying shape dependencies...

set Platform=%~1
echo Platform: %Platform%

set OutputDir=%~2
echo OptupDir: %OutputDir%

if not exist "%OutputDir%\Resources"                  mkdir "%OutputDir%\Resources\"
if not exist "%OutputDir%\Resources\chart_resources"  mkdir "%OutputDir%\Resources\chart_resources\"
if not exist "%OutputDir%\Resources\patterns"         mkdir "%OutputDir%\Resources\patterns\"

if not exist "%OutputDir%\Resources\GLSL"             mkdir "%OutputDir%\Resources\GLSL\"
if not exist "%OutputDir%\Resources\HLSL_Cg"  	      mkdir "%OutputDir%\Resources\HLSL_Cg\"
if not exist "%OutputDir%\Resources\ShadowVolume"     mkdir "%OutputDir%\Resources\ShadowVolume\"

xcopy /D /Y /S /I "%~dp0\patterns" "%OutputDir%\Resources\patterns"
xcopy /D /Y /S /I "%~dp0\textures" "%OutputDir%\Resources\textures"

xcopy /D /Y /S /I "%~dp0\GLSL" "%OutputDir%\Resources\GLSL"
xcopy /D /Y /S /I "%~dp0\HLSL_Cg" "%OutputDir%\Resources\HLSL_Cg"
xcopy /D /Y /S /I "%~dp0\ShadowVolume" "%OutputDir%\Resources\ShadowVolume"