class __MS_App
{
	getDoc(cDocId)
	{
		for(var i = 0; i < _openedDocs.length; i++)
		{
			if(cDocId == _openedDocs[i].msObjectId)
			{
				return _openedDocs[i];
			}
		}
		return null;
	}
	
	alert()
	{
		return MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("alert"), MSParam(ArgsAsArray(arguments))));
	}
	
	beep()
	{
		return MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("beep"), MSParam(ArgsAsArray(arguments))));
	}
	
	launchURL()
	{
		return MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("launchURL"), MSParam(ArgsAsArray(arguments))));
	}
	
	get calculate()
	{
		return MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("getCalculate"), MSParam(ArgsAsArray(arguments))));
	}
    set calculate(val)
	{
		msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("setCalculate"), MSParam(ArgsAsArray(arguments)));
	}
	get platform()
	{
		return MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("getPlatform"), MSParam(ArgsAsArray(arguments))));
	}
	get viewerType()
	{
		return MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("getViewerType"), MSParam(ArgsAsArray(arguments))));
	}
	get viewerVariation()
	{
		return MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("getViewerVariation"), MSParam(ArgsAsArray(arguments))));
	}
	get viewerVersion()
	{
		return MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("getViewerVersion"), MSParam(ArgsAsArray(arguments))));
	}
	openDoc()
	{
		var msObjectId = MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("openDoc"), MSParam(ArgsAsArray(arguments))));
		addOpenedDocument(msObjectId);
		return _currentDoc;
	}
	newDoc()
	{
		var msObjectId = MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("newDoc"), MSParam(ArgsAsArray(arguments))));
		addOpenedDocument(msObjectId);
		return _currentDoc;
	}
	get activeDocs()
	{
		var docIds = MSResult(msApp.sendToApp(MSParam("app"), MSParam(""), MSParam("getActiveDocs"), MSParam(ArgsAsArray(arguments))));
		var docs = [];
		for(var i = 0; i < docIds.length; i++)
		{
			for(var j = 0; j < _openedDocs.length; j++)
			{
				if(docIds[i] == _openedDocs[j].msObjectId)
				{
					docs.push(_openedDocs[j]);
				}
			}
		}
		return docs;
	}
}

const app = new __MS_App();
this.app = app;
