var Field= function(cDocId, cName){
    this.getNameInternal= function(){return cName;};
	this.getDocId= function(){return cDocId;};
};


Field.prototype= {
    get name(){return this.getNameInternal();},
    
	get doc(){return app.getDoc(this.getDocId());},
	
	get value(){
		var value= MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getValue"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
        try {
            var trimmedValue = value.trim();
            if (trimmedValue.length > 0) {
                var num = new Number(trimmedValue);
                if (!isNaN(num))
                    return num.valueOf();
            }
        }
        catch(error)
        {
        }

		return value;	
	},
	
    set value(val){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setValue"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
    },

    get valueAsString() {
        return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getValue"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
    },
	
	getArray: function(){
		var names= MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getChildren"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
		var res= new Array(names.length);
		for(var i= 0; i<names.length; i++){
			res[i]= new Field(this.getDocId(), names[i]);
		}
		return res;
	},
	
	isBoxChecked: function(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("isBoxChecked"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	
	set hidden(val){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setHidden"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	
	get hidden(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getHidden"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	set print(val){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setPrint"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	
	get print(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getPrint"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	set display(val){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setDisplay"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	get display(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getDisplay"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	buttonSetCaption: function()
	{
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("buttonSetCaption"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	buttonGetCaption: function()
	{
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("buttonGetCaption"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	get borderStyle(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getBorderStyle"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	set borderStyle(nBorderStyle){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setBorderStyle"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	get page(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getPage"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	set rect(val){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setRect"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	get rect(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getRect"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	get currentValueIndices(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getCurrentValueIndices"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	set fillColor(val){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setFillColor"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	get fillColor(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getFillColor"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	set bgColor(val){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setBgColor"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	get bgColor(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getBgColor"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	set strokeColor(val){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setStrokeColor"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	get strokeColor(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getStrokeColor"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	set borderColor(val){
		msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setBorderColor"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
	},
	get borderColor(){
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getBorderColor"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
	},
	setFocus: function()
	{
		return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setFocus"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
    },
    setAction: function () {
        return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setAction"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
    },
    get type() {
        return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getType"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
    },
    get charLimit() {
        return MSResult(msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("getCharLimit"), MSParam(ExtendedArgsAsArray(this.name, arguments))));
    },
    set charLimit(num) {
        msApp.sendToApp(MSParam("field"), MSParam(this.getDocId()), MSParam("setCharLimit"), MSParam(ExtendedArgsAsArray(this.name, arguments)));
    },
}

var display= {
	get visible(){
		return 0;
	},

	get hidden(){
		return 1;
	},

	get noPrint(){
		return 2;
	},

	get noView(){
		return 3;
	}
}

var border= {
	get s(){
		return "solid";
	},

	get d(){
		return "dashed";
	},

	get b(){
		return "beveled";
	},

	get i(){
		return "inset";
	},
	
	get u(){
		return "underline";
	}
}