var _openedDocs = [];
var _currentDoc = null;

function addOpenedDocument(msObjectId){
	
	if(msObjectId != null)
	{
		var pos = -1;
		for(var i = 0; i < _openedDocs.length; i++)
		{
			if(_openedDocs[i].msObjectId == msObjectId)
			{
				pos = i;
				break;
			}
		}
		if((pos >= 0) && (pos < _openedDocs.length))
		{
			_openedDocs.splice(pos, 1);
		}
		
		_currentDoc = new Doc(msObjectId);
		_openedDocs.push(_currentDoc);
	}
	else
	{
		_currentDoc = null;
	}
	
	if(_currentDoc != null)
	{
		_currentDoc.docProxy = new Proxy(_currentDoc, new DocProxyHandler(this));
	}
}

function ArgsAsArray(arguments)
{
	var arr =  new Array;
	for(var i = 0; i < arguments.length; i++)
		arr.push(arguments[i]);
	return arr;
}

function ExtendedArgsAsArray(cFieldName, arguments)
{
	var arr = ArgsAsArray(arguments);
	arr.splice(0, 0, cFieldName);
	return arr;
}


